# vega-transforms

Data processing transforms for Vega dataflows.

This package provides the following Vega data transforms:

- [**Aggregate**](https://vega.github.io/vega/docs/transforms/aggregate/) [&lt;&gt;](https://github.com/vega/vega/blob/master/packages/vega-transforms/src/Aggregate.js "Source")
- [**Bin**](https://vega.github.io/vega/docs/transforms/bin/) [&lt;&gt;](https://github.com/vega/vega/blob/master/packages/vega-transforms/src/Bin.js "Source")
- [**Collect**](https://vega.github.io/vega/docs/transforms/collect/) [&lt;&gt;](https://github.com/vega/vega/blob/master/packages/vega-transforms/src/Collect.js "Source")
- [**CountPattern**](https://vega.github.io/vega/docs/transforms/countpattern/) [&lt;&gt;](https://github.com/vega/vega/blob/master/packages/vega-transforms/src/CountPattern.js "Source")
- [**Cross**](https://vega.github.io/vega/docs/transforms/cross/) [&lt;&gt;](https://github.com/vega/vega/blob/master/packages/vega-transforms/src/Cross.js "Source")
- [**Density**](https://vega.github.io/vega/docs/transforms/density/) [&lt;&gt;](https://github.com/vega/vega/blob/master/packages/vega-transforms/src/Density.js "Source")
- [**DotBin**](https://vega.github.io/vega/docs/transforms/dotbin/) [&lt;&gt;](https://github.com/vega/vega/blob/master/packages/vega-transforms/src/DotBin.js "Source")
- [**Extent**](https://vega.github.io/vega/docs/transforms/extent/) [&lt;&gt;](https://github.com/vega/vega/blob/master/packages/vega-transforms/src/Extent.js "Source")
- [**Filter**](https://vega.github.io/vega/docs/transforms/filter/) [&lt;&gt;](https://github.com/vega/vega/blob/master/packages/vega-transforms/src/Filter.js "Source")
- [**Flatten**](https://vega.github.io/vega/docs/transforms/flatten/) [&lt;&gt;](https://github.com/vega/vega/blob/master/packages/vega-transforms/src/Flatten.js "Source")
- [**Fold**](https://vega.github.io/vega/docs/transforms/fold/) [&lt;&gt;](https://github.com/vega/vega/blob/master/packages/vega-transforms/src/Fold.js "Source")
- [**Formula**](https://vega.github.io/vega/docs/transforms/formula/) [&lt;&gt;](https://github.com/vega/vega/blob/master/packages/vega-transforms/src/Formula.js "Source")
- [**Impute**](https://vega.github.io/vega/docs/transforms/Impute/) [&lt;&gt;](https://github.com/vega/vega/blob/master/packages/vega-transforms/src/Impute.js "Source")
- [**JoinAggregate**](https://vega.github.io/vega/docs/transforms/joinaggregate/) [&lt;&gt;](https://github.com/vega/vega/blob/master/packages/vega-transforms/src/JoinAggregate.js "Source")
- [**KDE**](https://vega.github.io/vega/docs/transforms/kde/) [&lt;&gt;](https://github.com/vega/vega/blob/master/packages/vega-transforms/src/KDE.js "Source")
- [**Lookup**](https://vega.github.io/vega/docs/transforms/lookup/) [&lt;&gt;](https://github.com/vega/vega/blob/master/packages/vega-transforms/src/Lookup.js "Source")
- [**Pivot**](https://vega.github.io/vega/docs/transforms/pivot/) [&lt;&gt;](https://github.com/vega/vega/blob/master/packages/vega-transforms/src/Pivot.js "Source")
- [**Project**](https://vega.github.io/vega/docs/transforms/project/) [&lt;&gt;](https://github.com/vega/vega/blob/master/packages/vega-transforms/src/Project.js "Source")
- [**Quantile**](https://vega.github.io/vega/docs/transforms/quantile/) [&lt;&gt;](https://github.com/vega/vega/blob/master/packages/vega-transforms/src/Quantile.js "Source")
- [**Sample**](https://vega.github.io/vega/docs/transforms/sample/) [&lt;&gt;](https://github.com/vega/vega/blob/master/packages/vega-transforms/src/Sample.js "Source")
- [**Sequence**](https://vega.github.io/vega/docs/transforms/sequence/) [&lt;&gt;](https://github.com/vega/vega/blob/master/packages/vega-transforms/src/Sequence.js "Source")
- [**TimeUnit**](https://vega.github.io/vega/docs/transforms/timeunit/) [&lt;&gt;](https://github.com/vega/vega/blob/master/packages/vega-transforms/src/TimeUnit.js "Source")
- [**Window**](https://vega.github.io/vega/docs/transforms/window/) [&lt;&gt;](https://github.com/vega/vega/blob/master/packages/vega-transforms/src/Window.js "Source")

And provides the following internal transforms:

- **Compare** [&lt;&gt;](https://github.com/vega/vega/blob/master/packages/vega-transforms/src/Compare.js "Source")
- **Expression** [&lt;&gt;](https://github.com/vega/vega/blob/master/packages/vega-transforms/src/Expression.js "Source")
- **Facet** [&lt;&gt;](https://github.com/vega/vega/blob/master/packages/vega-transforms/src/Facet.js "Source")
- **Field** [&lt;&gt;](https://github.com/vega/vega/blob/master/packages/vega-transforms/src/Field.js "Source")
- **Generate** [&lt;&gt;](https://github.com/vega/vega/blob/master/packages/vega-transforms/src/Generate.js "Source")
- **Key** [&lt;&gt;](https://github.com/vega/vega/blob/master/packages/vega-transforms/src/Key.js "Source")
- **MultiExtent** [&lt;&gt;](https://github.com/vega/vega/blob/master/packages/vega-transforms/src/MultiExtent.js "Source")
- **MultiValues** [&lt;&gt;](https://github.com/vega/vega/blob/master/packages/vega-transforms/src/MultiValues.js "Source")
- **Params** [&lt;&gt;](https://github.com/vega/vega/blob/master/packages/vega-transforms/src/Params.js "Source")
- **PreFacet** [&lt;&gt;](https://github.com/vega/vega/blob/master/packages/vega-transforms/src/PreFacet.js "Source")
- **Proxy** [&lt;&gt;](https://github.com/vega/vega/blob/master/packages/vega-transforms/src/Proxy.js "Source")
- **Relay** [&lt;&gt;](https://github.com/vega/vega/blob/master/packages/vega-transforms/src/Relay.js "Source")
- **Sieve** [&lt;&gt;](https://github.com/vega/vega/blob/master/packages/vega-transforms/src/Sieve.js "Source")
- **Subflow** [&lt;&gt;](https://github.com/vega/vega/blob/master/packages/vega-transforms/src/Subflow.js "Source")
- **TupleIndex** [&lt;&gt;](https://github.com/vega/vega/blob/master/packages/vega-transforms/src/TupleIndex.js "Source")
- **Values** [&lt;&gt;](https://github.com/vega/vega/blob/master/packages/vega-transforms/src/Values.js "Source")

For more information about data stream transforms, see the [Vega transform documentation](https://vega.github.io/vega/docs/transforms/).
